#!/usr/bin/ruby

require File.join(File.dirname(__FILE__), 'rubyreq')

def process_file(f)
  prefix, name = RubyReq::explode f
  if prefix and name
    basename, ext = RubyReq::base_ext(name)
    $prov[name] = nil unless ext == '.rb'
    $prov[basename] = nil if ['.rb', '.so'].include? ext
  else
    raise "# #{f}: file outside of any known library paths" if ENV['RPM_BUILD_RUBY_VERBOSE']
  end
end

$prov = Hash.new

RubyReq::argv.each do |f|
  begin
    process_file(f)
  rescue => err
    RubyReq::warn err.message
    exit 1 if RubyReq::method == 'strict'
  end
end

$prov.keys.sort.each do |r|
  puts "ruby(#{r})"
end

# vim: set ft=ruby ts=2 sts=2 sw=2 et:
