module RubyReq

  def self.argv
    f = ARGV
    f = ($stdin.readlines.collect { |l| l.chomp }).find_all { |l| l.length > 0 } if f.empty?
    raise "#{$0}: no files" unless f and not f.empty?
    f.collect { |l| if File.exists? l then File.expand_path l else raise "#{$0}: #{l} does not exists" end }
  end

  @@method = ENV['RPM_RUBY_REQ_METHOD'] || 'relaxed'
  def self.method
    @@method
  end

  @@root = ENV['RPM_BUILD_ROOT']
  @@root &&= File.expand_path(@@root)
  def self.root
    @@root
  end

  @@inc = nil
  def self.inc
    unless @@inc
      @@inc = Array.new
      @@inc.unshift(($:.select{ |p| p != '.' }).collect{ |p| File.expand_path(p) }).flatten!
      @@inc.unshift(((ENV['RPM_RUBY_LIB_PATH'] || '').split).collect{ |p| File.expand_path(p) }).flatten!
      @@inc.unshift(@@inc.collect{ |p| File.join(@@root, p) }).flatten! if @@root
      @@inc.reject! { |p| not File.directory?(p) }
      @@inc.uniq!
    end
    @@inc
  end

  def self.split_canon(fname)
    fs = fname.split(/#{File::SEPARATOR}+/)
    fc = File.join(fs)
    return [fc, fs]
  end

  def self.base_ext(fname)
    ext = File.extname(fname)
    basename = File.basename(fname, ext)
    basename = File.join(File.dirname(fname), basename) unless File.dirname(fname) == "."
    [basename, ext]
  end

  def self.explode(fname)
    prefix = (inc().sort { |a,b| b.length <=> a.length }).find { |p| fname.index(p) == 0 and fname[p.length].chr == File::SEPARATOR }
    return unless prefix
    basename = fname[prefix.length+1..-1]
    return unless basename
    return [prefix, basename]
  end

  def self.warn(str)
    $stderr.puts "#{File.basename($0)}: #{str}"
  end

  def self.system(*args)
    Process.fork do
      $stdout.reopen("/dev/null", "w")
      Kernel.exec(*args)
    end
    Process.wait
    return $?.exitstatus
  end
end
# vim: set ft=ruby ts=2 sts=2 sw=2 et:
